import React,{Component} from 'react';
import className from 'classnames';
import {NumberUnitPan} from '@commonComp';
import style from './index.less';
import config from '@config/index.js';
import {filterArr,handleEnter} from '@utils/tools.js';
import {Notify} from '@commonComp';
/***
 * 带单位数字组件
 * 接收参数：
 * value: 默认选中的值
 * placeholder：灰显文字
 * handleSelect: 选中事件
 * show: 是否显示下拉
 *
 * ***/
class NumberUnitDrop extends Component{
  constructor(props){
    super(props);
    this.state={
      editable:false,      //标签是否可输入
      numEditable:true,      //数字框是否可输入
      timer:null,
      hasSelect:false,       //是否点过下拉键盘
      isClosed:false,
      value:props.value,
      placeholderFlag:false,
      labelVal:''
    };
    this.$span = React.createRef();
    this.select = this.select.bind(this);
    this.numInpBlur = this.numInpBlur.bind(this);
    this.handleSpanInp = this.handleSpanInp.bind(this);
    this.handleNumClick = this.handleNumClick.bind(this);
    this.changeToEdit = this.changeToEdit.bind(this);
  }
  select(text){         //选中键盘上数字事件
    const {handleSelect,ikey,suffix,prefix,mainSaveText} = this.props;
    this.setState({
      hasSelect:true
    });
    if(!text){
      this.setState({
        value:''
      });
    }
    handleSelect&&handleSelect({ikey,text,suffix,prefix,mainSaveText});
  }
  
  handleNumClick(e){ 
    e.stopPropagation();
    const {show,handleShow,ikey,id,patId,handleHide,value} = this.props;
    const {hasSelect} = this.state;
    const that = this;
    //双击时不显示下拉
    clearTimeout(this.state.timer);
    const timer = setTimeout(function(){
      const {hasSelect,editable,isClosed} = that.state;
      if(editable||isClosed){
        return;
      }
      handleShow&&handleShow({ikey,id:patId||id});
    },300);
    this.setState({
      timer
    });
    handleHide&&handleHide();
  }
  //数字框失焦，保存值到store中
  numInpBlur(e){
    e.stopPropagation();
    this.setState({
      isClosed:false,
      numEditable:true,
      hasSelect:false,
      editable:false
    });
    const text = e.target.innerText;
    this.$span.current.innerText='';      //修改生成文字变成输入的2倍bug
    const {handleSelect,ikey,suffix,prefix,mainSaveText} = this.props;
    handleSelect&&handleSelect({ikey,text,suffix,prefix,mainSaveText});
  }

  handleSpanInp(e){ //数字框输入事件
    e.stopPropagation();
    // 主诉字数达到上限时不允许输入
    const {mainSaveText,ikey,type,handleSelect,suffix,prefix,boxMark} = this.props;
    const {labelVal} = this.state;
    let mainText = filterArr(mainSaveText);//主诉字数
    let val = e.target.innerText;
    if(+boxMark==1){
      if(mainText.length >= config.limited){
        if(val.length > labelVal.length){
          e.target.innerText = labelVal;
          Notify.info(config.limitText);
          return
        }else if(val.length == labelVal.length){
          this.setState({
            labelVal:val
          });
        }else{
          handleSelect&&handleSelect({ikey,text:val,suffix,prefix,mainSaveText});
        }
      }
    }
  }
  getClasses(){         //整个标签是否有值的状态
    const {value,hideTag} = this.props;
    const inpValue = this.state.value;
    const isSelected = value||inpValue?style['selected']:style['container'];
    const noTag = hideTag?style['no-tag']:'';
    return className(isSelected,noTag);
  }
  changeToEdit(e){        //整个标签双击编辑状态
    e.stopPropagation();
    const {value,id,handleDbclick,patId} = this.props;
    const text = e.target.innerText;
    // clearTimeout(this.state.timer);//取消延时的单击事件
    if(value&&value.trim()) {//有选中值的标签才能双击编辑
      this.setState({
        editable: true,
        labelVal:text
      });
      e.target.focus();
      //双击埋点记录
      handleDbclick && handleDbclick({id:patId||id});
    }
  }

  render(){
    const {placeholder,prefix,suffix,show,value,handleHide} = this.props;
    const {numEditable,editable,hasSelect,placeholderFlag} = this.state;
    return <div className={this.getClasses()}>
      <span>{prefix}</span>
      <span onClick={this.handleNumClick}
            contentEditable={editable}
            ref = {this.$span}
            onBlur={this.numInpBlur}
            onInput={this.handleSpanInp}
            onDoubleClick={this.changeToEdit}
            onkeydown={handleEnter}
            style={{cursor:editable?'text':'pointer'}}>{value||placeholder}</span>
      <span>{suffix}</span>
      <NumberUnitPan handleSelect={(text)=>this.select(text)}
                 onClose={handleHide}
                 show={show} toClear={!hasSelect} value={value}/>
    </div>
  }
}

export default NumberUnitDrop;